package com.management.platform.controller;


import com.management.platform.service.ProjectService;
import com.management.platform.util.HttpRespMsg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author 吴涛涛
 * @since 2020-01-03
 */
@RestController
@RequestMapping("/project")
public class ProjectController {
    @Autowired
    private ProjectService projectService;

    /**
     * 获取项目列表
     */
    @RequestMapping("/getProjectList")
    public HttpRespMsg getProjectList() {
        return projectService.getProjectList();
    }

    /**
     * 添加或编辑项目
     * id 要编辑项目的id 可填
     * name 项目的名称
     */
    @RequestMapping("/editProject")
    public HttpRespMsg editProject(Integer id, @RequestParam String name) {
        return projectService.editProject(id, name);
    }

    /**
     * 删除项目
     * id 要删除的项目的id
     */
    @RequestMapping("/deleteProject")
    public HttpRespMsg deleteProject(@RequestParam Integer id) {
        return projectService.deleteProject(id);
    }
}

