package com.management.platform.controller;


import com.management.platform.service.UserService;
import com.management.platform.util.HttpRespMsg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author 吴涛涛
 * @since 2019-12-31
 */
@RestController
@RequestMapping("/user")
public class UserController {
    @Autowired
    private UserService userService;

    /**
     * 管理员登录网页端
     * username 用户名
     * password 密码
     */
    @RequestMapping("/loginAdmin")
    public HttpRespMsg loginAdmin(@RequestParam String username, @RequestParam String password) {
        return userService.loginAdmin(username, password);
    }

    /**
     * 员工登录PC端
     * username 用户名
     * password 密码
     */
    @RequestMapping("/loginEmployee")
    public HttpRespMsg loginEmployee(@RequestParam String username, @RequestParam String password) {
        return userService.loginEmployee(username, password);
    }
}

