package com.management.platform.task;

import java.time.format.DateTimeFormatter;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.management.platform.constant.Constant;
import com.management.platform.entity.Screenshot;
import com.management.platform.mapper.ScreenshotMapper;
import com.management.platform.service.ScreenshotService;
import com.management.platform.util.AuthService;
import com.management.platform.util.CheckPicUtil;
import com.management.platform.util.RedisUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAccessor;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * Author: 吴涛涛
 * Date : 2019 - 12 - 31 16:04
 * Description:<描述>
 * Version: 1.0
 */
@EnableScheduling
@Component
public class TimingTask {
    @Autowired
    private RedisUtil redisUtil;

    @Resource
    private ScreenshotMapper screenshotMapper;

    @Value(value = "${upload.path}")
    private String path;

    //    @Scheduled(cron = "0 */5 * * * ?")//配置时间段触发(每五分钟触发一次)
    public void pictureDetectionTask() {
        String accessToken = "";

        if (redisUtil.existsKey("accessToken")) {
            accessToken = redisUtil.getKey("accessToken");
        } else {
            Map<String, Object> map = AuthService.getAuth(Constant.API_KEY, Constant.SECRET_KEY);
            accessToken = (String) map.get("access_token");
            Long expiresTimeOut = (Long) map.get("expires_in");
            redisUtil.setKeyWithExpireTime("accessToken", accessToken, expiresTimeOut);
        }
        //利用token去检测
//        DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
//        LocalDateTime l = LocalDateTime.parse("2019-02-03",dateTimeFormatter);
        List<Screenshot> screenshots = screenshotMapper.selectList(new QueryWrapper<Screenshot>()
                .eq("date_str", DateTimeFormatter.ofPattern("yyyy-MM-dd").format(LocalDateTime.now()))
                .eq("is_handle", Constant.UN_HANDLE));
        for (Screenshot screenshot : screenshots) {
            List<String> textContents = CheckPicUtil.generalPicTextContent(path + screenshot.getPicUrl().substring("/upload/".length()), accessToken);
            Set<Object> members = redisUtil.members(Constant.COMMON_SOFTWARE_KEYWORDS);
            for (String textContent : textContents) {
                for (Object member : members) {
                    if (textContent.contains((String) member)) {
                        //包含关键字们可以简单认为是在用常用开发软件
                        //to do 确定图片是哪个类型的图片
                    }
                }
            }
        }
    }
}
