package com.management.platform.util;

import org.apache.log4j.Logger;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;

public class ProcessUtil {
    private static BufferedReader out;
    private static BufferedReader err;
    public static Logger logger = Logger.getLogger(ProcessUtil.class);
    public static void testProcess() {
        // 创建系统进程
        try {
            ProcessBuilder pb = new ProcessBuilder("tasklist");
            Process p = pb.start();
            out = new BufferedReader(new InputStreamReader(new BufferedInputStream(p.getInputStream()), Charset.forName("GB2312")));
            err = new BufferedReader(new InputStreamReader(new BufferedInputStream(p.getErrorStream())));
            System.out.println("Window 系统进程列表");
            String ostr;
//            System.out.println(out.readLine());
//            System.out.println(err.readLine());
            // 创建集合 存放 进程+pid
            List<String> list = new ArrayList<>();
            while (out.readLine()!= null) {
                System.out.println(out.readLine());
                list.add(out.readLine());
            }
            // 遍历所有进程
            for (int i = 3; i < list.size(); i++) {
                // 必须写死,截取长度,因为是固定的
                String process = list.get(i).substring(0, 25).trim(); // 进程名
                String pid = list.get(i).substring(25, 35).trim();    // 进程号
                // 匹配指定的进程名,若匹配到,则立即杀死
                if (process.startsWith("Thunder")) {
                    System.out.println("关闭迅雷");
                    Runtime.getRuntime().exec("taskkill /F /PID " + pid);
                }
            }

            // 若有错误信息 即打印日志
            String estr = err.readLine();
            if (estr != null) {
                logger.error(estr);
            }
        } catch (
                IOException e) {
            e.printStackTrace();
        } finally {
            // 关流
            try {
                if (out != null) {
                    out.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                if (err != null) {
                    err.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public static void main(String[] args) {
        testProcess();
    }

}