var path = require('path')

var os = require('os'), ip = '', ifaces = os.networkInterfaces() // 获取本机ip
for (var i in ifaces) {
    for (var j in ifaces[i]) {
        var val = ifaces[i][j]
        if (val.family === 'IPv4' && val.address !== '127.0.0.1') {
            ip = val.address
        }
    }
}

module.exports = {
  build: {
    env: require('./prod.env'),
    index: path.resolve(__dirname, '../dist/index.html'),
    assetsRoot: path.resolve(__dirname, '../dist'),
    assetsSubDirectory: 'static',
    assetsPublicPath: './',
    productionSourceMap: true,
    productionGzip: false,
    productionGzipExtensions: ['js', 'css'],
    bundleAnalyzerReport: process.env.npm_config_report
  },
  dev: {
    env: require('./dev.env'),
    port: 10086,
    autoOpenBrowser: true,
    assetsSubDirectory: 'static',
    assetsPublicPath: '/',
    proxyTable: {
        '/api': {    
            target: 'http://'+ ip +':8099',
            secure: true,
            changeOrigin: true,
            pathRewrite: {
                '^/api': '/' 
            }
        },
        '/ips': {    
            target: 'http://'+ ip +':8080',
            secure: true,
            changeOrigin: true,
            pathRewrite: {
                '^/ips': '/' 
            }
        },
    },
    cssSourceMap: false
  }
}
