export default {
    manage: {
        login: '/user/login', // 登录
    },
    //消息提示相关
    notice: {
        list: '/vnoticeuser/list',  // 消息列表
        read: '/vnoticeuser/read'  // 消息读取
    },
    pwd: {
        resetPwd: '/user/updatePassword' // 重置密码
    },
    map: { 
        mapList: '/company/getCoutomCompanyAndMouldsByUser', // 生产方公司和公司下所属的模具
        newMap: '/mould/listMap' // 获取地图
    },
    project: {
        addUser: '/user/add',  // 添加或修改用户
        userList: '/user/list',  // 用户列表
        delUser: '/user/delete',  // 删除用户

        addProject: '/project/add', // 添加或修改项目
        projectList: '/project/list', // 项目列表
        projectDetail: '/project/detail', // 项目详情
        projects: '/project/projectList', // 筛选模具列表时作为筛选条件所加载的项目列表
        projectByUser: '/project/getProjectListByUserAndCompany',// 获取创建人员分配项目时根据当前人和公司获取项目列表

        uploadFile: '/projectfile/uploadFile', //项目文档的上传
        dowloadFile: '/projectfile/dowloadFile', //项目文档的下载
        fileList: '/projectfile/list', //项目文档列表
        delFile: '/projectfile/delFile', //项目文档的删除
        operList: '/projectoperationdynamics/list', //项目操作记录列表

        getUserList: '/user/getUserList', //获取用户列表
        getUserById: '/user/getUserListByCompanyIds', // 给项目分配参与人的时候根据公司id获取公司下的人员

        inviteUser: '/invitationrecord/inviteUser', //添加邀请记录并产生链接

        powerList: '/power/list', // 权限列表
        powerUpdate: '/power/update', //修改权限
    },
    //模具
    mold: {
        addMold: '/mould/addOrUpdate', //添加/修改模具设备
        molds: '/mould/list', //模具列表
        modelList: '/mould/modelList', //给项目分配模具获取该公司下的模具列表
        delMold: '/mould/delMould', //删除模具

        moldDetail: '/mould/detail', //模具详情
        moldFileList: '/mouldfile/list', //获取模具文档
        moldFileListAll: '/mouldfile/allList', //获取全部模具文档
        moldFileUpload: '/mouldfile/uploadFile', //上传模具文档
        moldFileDowload: '/mouldfile/dowloadFile', //模具文档的下载
        moldFileDowloadList: '/mouldfile/fileList', //获取模具文档下载列表

        moldFileDowloadFile: '/mouldfile/downloadfileList', //批量下载
        moldFileCheck: '/mouldfile/check', //审批模具文档 
        exportOperationExcel: '/mouldfile/downloadFileListExcel', //下载操作记录

        chooseModelList: '/mould/chooseModelList', //编辑项目时显示的模具列表

        moldFileDelete: '/mouldfile/delFile', //项目文档的删除
        moldOperationList: '/mouldoperationdynamics/list', //项目操作记录列表

        partList: '/part/list', //零件列表
        addPart: '/part/addOrUpdate', //单个零件添加
        importPart: '/part/importAppLogin',//零件的excel导入
        partUpload: '/mouldfile/uploadPartFileList', //零件文档的批量上传

        download: '/mouldfile/download',

        moldMaintain: '/mouldmaintain/maintain', //维护
        moldMaintainList: '/mouldmaintain/list', //获取列表
        moldMaintainListGet: '/mould/maintainMouldList', //主页获取保养模具列表
        moldDiscardListGet: '/mould/scrapMouldList', //主页获取报废模具列表
        moldChange: '/mould/changeMouldEquipment', //处理告警
        moldChangeRequirement: '/mouldequipment/getEquipmentListByOldMouldAndUser' //处理告警所需的设备
    },
    //基础管理
    base: {
        addCompany: '/company/add', // 添加资产方
        companyList: '/company/list', // 资产方列表
        delCompany: '/company/delete', // 删除资产方

        getCompanyList: '/company/getCompanyList', // 管理员创建人员时显示公司
        
        getCompanys: '/company/getCompanys', // 云模盒所属公司

        addCompanyListToProject: '/company/addCompanyListToProject', // 编辑项目时获取生产方公司

        relationList: '/company/relationList', // 获取关联公司列表

        //ownerComps: '/company/ownerRelateCompany', // 返回当前公司的关联公司列表

        getProduceCompany: '/company/getProduceCompany', // 根据项目id获取生产方列表
        
        getInfo: '/company/getProduceCompanyByCurrentUser', // 根据当前人登录人所能看到的公司进行筛选

        addFactory: '/factory/add',  // 添加生产方
        factoryList: '/factory/list',   // 生产方列表
        delFactory: '/factory/delete',  // 删除生产方

        editMould: '/mouldequipment/addOrUpdate', // 添加 / 修改云模盒
        mouldeList: '/mouldequipment/getEquipmentList', // 云模盒列表
        enableMould: '/mouldequipment/use', // 启用云模盒

        moulds: '/mouldequipment/getMouldEquipmentList', // 创建模具时获取资产方的云模盒列表
        importMouldEquipmentExcel: '/mouldequipment/importMouldEquipmentExcel', //批量导入云模盒
        
        setPacket: '/mouldequipment/use',// 云平台下行配置数据包接口
        openingAndClosingTimesChart: '/mouldhistory/openingAndClosingTimesChart', //获取云模盒的每日开合次数图表 (时间/次数)
        openingAndClosingTimesChartCycle: '/mouldhistory/openingAndClosingTimesChartCycle', //获取云模盒的每日开合次数周期 (时间/次数)

    },
    file: {
        view: '/pdffile/getPdfFile' // 文件预览
    }
}