import Login from './views/Login.vue'
import NotFound from './views/404.vue'
import Home from './views/Home.vue'

// new router
// 今日桌面
import desktop from './views/desktop'
import desktopDetail from './views/desktop/detail.vue'
import unusual from './views/desktop/unusual.vue'

// 工作报告
import statistics from './views/workReport/statistics.vue'
import daily from './views/workReport/daily.vue'

// 团队管理
import team from './views/team/index.vue'

// 系统管理
import system from './views/system/index.vue'

let routes = [
    {
        path: '/login',
        component: Login,
        name: '',
        hidden: true
    },
    //今日桌面
    {
        path: '/',
        component: Home,
        name: '今日桌面',
        iconCls: 'fa fa-desktop',
        children: [
            { path: '/desktop', component: desktop, name: '桌面查看' },
            { path: '/desktop/:id', component: desktopDetail, name: '个人桌面', hidden: true },
            { path: '/unusual', component: unusual, name: '异常统计' },
        ]
    },
    //工作报告
    {
        path: '/',
        component: Home,
        name: '工作报告',
        iconCls: 'fa fa-sticky-note',
        children: [
            { path: '/statistics', component: statistics, name: '工时统计' },
            { path: '/daily', component: daily, name: '工作日报' },
        ]
    },
    //团队管理
    {
        path: '/',
        component: Home,
        name: '',
        iconCls: 'fa fa-users',
        leaf: true,//只有一个节点
        children: [
            { path: '/team', component: team, name: '团队管理' },
        ]
    },
    //系统管理
    {
        path: '/',
        component: Home,
        name: '',
        iconCls: 'fa fa-cog',
        leaf: true,//只有一个节点
        children: [
            { path: '/system', component: system, name: '系统管理' },
        ]
    },
    {
        path: '/404',
        component: NotFound,
        name: '',
        hidden: true
    },
    {
        path: '*',
        hidden: true,
        redirect: { path: '/404' }
    }
];

export default routes;
